/*-----------------------------------------*/
/*--------脚本参照阿里云物联网平台文档-----*/
/*-----------使用十六进制传输--------------*/
/*--------上传参数LightVolt;PowerSwitch----*/
/*-----------作者：如果能编程回忆----------*/
/*---------Email：admin@lovemcu.cn---------*/
/*---------------QQ: 891652120-------------*/
/*-----------------------------------------*/

//测试数据0x000320F2E30000000001
var COMMAND_REPORT = 0x00;  //上报数据头
var COMMAND_SET = 0x01;		//下发数据头
var ALINK_PROP_REPORT_METHOD = 'thing.event.property.post'; //标准ALink JSON格式topic， 设备 上传属性数据到 云端
var ALINK_PROP_SET_METHOD = 'thing.service.property.set'; //标准ALink JSON格式topic， 云端 下发属性控制指令 到设备端
  
   
function rawDataToProtocol(bytes) {
	var uint8Array = new Uint8Array(bytes.length);
	for (var i = 0; i < bytes.length; i++) {
		uint8Array[i] = bytes[i] & 0xff;
	}
	var dataView = new DataView(uint8Array.buffer, 0);
	var jsonMap = new Object();
	var fHead = uint8Array[0];
	if (fHead == COMMAND_REPORT) {
		jsonMap['method'] = ALINK_PROP_REPORT_METHOD;
		jsonMap['version'] = '1.0';
		jsonMap['id'] = '' + dataView.getInt32(1);
		var params = {};
		params['LightVolt'] = dataView.getInt32(5);
		params['PowerSwitch'] = uint8Array[9];
		jsonMap['params'] = params;
	}
	return jsonMap;
}

function protocolToRawData(json) {
	var method = json['method'];
	var id = json['id'];
	var version = json['version'];
	var payloadArray = [];
	if (method == ALINK_PROP_SET_METHOD)
	{
		var params = json['params'];
		var prop_int32 = params['LightVolt'];
		var prop_bool = params['PowerSwitch'];
		//按照自定义协议格式拼接 rawdata
		payloadArray = payloadArray.concat(buffer_uint8(COMMAND_SET));
		payloadArray = payloadArray.concat(buffer_int32(parseInt(id)));
		payloadArray = payloadArray.concat(buffer_int32(parseInt(prop_int32)));
		payloadArray = payloadArray.concat(buffer_uint8(prop_bool));
	}
	return payloadArray;
}

//以下是部分辅助函数
function buffer_uint8(value) {
    var uint8Array = new Uint8Array(1);
    var dv = new DataView(uint8Array.buffer, 0);
    dv.setUint8(0, value);
    return [].slice.call(uint8Array);
}
function buffer_int16(value) {
    var uint8Array = new Uint8Array(2);
    var dv = new DataView(uint8Array.buffer, 0);
    dv.setInt16(0, value);
    return [].slice.call(uint8Array);
}
function buffer_int32(value) {
    var uint8Array = new Uint8Array(4);
    var dv = new DataView(uint8Array.buffer, 0);
    dv.setInt32(0, value);
    return [].slice.call(uint8Array);
}
function buffer_float32(value) {
    var uint8Array = new Uint8Array(4);
    var dv = new DataView(uint8Array.buffer, 0);
    dv.setFloat32(0, value);
    return [].slice.call(uint8Array);
}